package main

//#include <pthread.h>
//unsigned long tid(void) { return (unsigned long)pthread_self(); }
import "C"
import (
	"fmt"
	"os"
	"runtime"
	"strconv"
	"time"
)

type msg struct { // структура сообщения
	n int          // номер ветви
	t int64        // системный pthread_t
}
func (p msg) String() string {
	return "[" + strconv.Itoa(p.n) + "," +
	       strconv.FormatInt(p.t, 16) + "]"
}

func main() {
	fmt.Printf("число процессоров в системе: %v\n", runtime.NumCPU())
	ветви := 3
	if len(os.Args) > 1 {
		ветви, _ = strconv.Atoi(os.Args[1])
	}
	fmt.Printf("число ветвей выполнения: %v\n", ветви)
	ch := make(chan msg)
	t0 := time.Now()
	for i := 1; i <= ветви; i++ {
		go func(n int) {
			defer func() { ch <- msg{int(n), int64(C.tid())} }()
			t0, t1 := time.Now(), time.Now()
			for t1.Sub(t0).Seconds() < 1 {
				t1 = time.Now()
			}
		}(i)
	}
	for i := 1; i <= ветви; i++ {
		m := <-ch
		fmt.Printf("%s\n", m.String())
	}
	fmt.Printf("итоговое время выполнения: %v\n", time.Now().Sub(t0))
}

